       ORG $4f50-2
	DW $4f50

      	 SEI
      	 LDA #$00
      	 STA $ff16
      	 LDA #142
      	 JSR $ffd2
       LDA #147
       JSR $ffd2
       JSR LOGo
       LDX #irq & 255
       LDY #irq >> 8
       STX $fffe
       STY $ffff
       LDA #$02
       STA $ff0a
       LDA #$72
       STA $ff0b
       STA $ff3f
       CLI
xx     JMP xx
       STA $ff3e
       RTS

irq
       LDA $ff09
       STA $ff09
       LDA $ff0b
       CMP #$d0
       BEQ irq2
       CMP #$01
       BNE han
       JMP irq3
han    LDA #192
       STA 65298
       LDA #112
       STA 65299
       LDA weich
       STA $ff07
       JSR raster
       LDA #192
       STA 65298
       LDA #104
       STA 65299
       LDA #$08
       STA $ff07
       LDA #$40
       STA $fd30
       STA $ff08
       LDX #$02
klk    LDA $ff1d
iop    CMP $ff1d
       BEQ iop
       DEX
       BNE klk
       LDA weins
       STA $ff06
       LDA wzwei
       STA $ff1f
       LDA #$d0
       STA $ff0b
       RTI

irq2
       LDA #$1b
       STA $ff06
       LDA #00
       STA $ff1f
       LDA #$01
       STA $ff0b
      LDA #$71
      STA $ff15
       JSR scroll
       JSR upmanag
       JSR upcol
       JSR colmove
       LDX #$17
       LDY #$19
       STY z00+1
       STY z01+1
       STY z02+1
       STY z03+1
       STX y00+1
       STX y01+1
       STX y02+1
       STX y03+1
       LDA #$6e
       STA a02+1
       STA x01+1
       STA x02+1
       STA x03+1
       LDA #$03
       STA w00+1
       RTI

irq3
       LDA #192
       STA 65298
       LDA #124
       STA 65299
       LDA $ff07
       ORA #16
       STA $ff07
       LDA $ff1d
loo    CMP $ff1d
       BEQ loo
       JSR raster
       LDX #$19
       LDY #$15
       STY z00+1
       STY z01+1
       STY z02+1
       STY z03+1
       STX y00+1
       STX y01+1
       STX y02+1
       STX y03+1
       LDA #$00
       STA a02+1
       STA x01+1
       STA x02+1
       STA x03+1
       LDA #$72
       STA $ff0b
       LDA #$08
       STA w00+1
       RTI

raster
       LDA $ff1d
uu     CMP $ff1d
       BEQ uu
       LDX #$11   ;0c
hij    DEX
       BNE hij
       LDX #$00
b01    LDY #$00
a02    LDA $6000,x
y00    STA $ff19
       LDA $6050,x
z00    STA $ff15
       ORA ($ff,x)
       ORA ($ff,x)
       ORA ($ff,x)
       ORA ($ff,x)
       ORA ($ff,x)
       ORA ($ff,x)
       ORA $ff,x
       INX
       INY
       CPY #$05
       BNE a02
x01    LDA $6000,x
y01    STA $ff19
       LDA $6050,x
z01    STA $ff15
       ORA $ff,x
       INX
x02    LDA $6000,x
y02    STA $ff19
       LDA $6050,x
z02    STA $ff15
       INX
       ORA $ff,x
x03    LDA $6000,x
y03    STA $ff19
       LDA $6050,x
z03    STA $ff15
       INX
       LDY #$06
klm    DEY
       BNE klm
       ORA ($ff,x)
       DEC zaehler
       BNE b01
w00    LDA #$03
       STA zaehler
       RTS

zaehler
       DB $03

txaus
       LDA txmerk
       BNE k01
       INC txmerk
       JSR vORne
       RTS
k01    DEC txmerk
       JSR hINTen
       RTS
txmerk DB $00
       RTS

scroll
       DEC weich
       LDA weich
       CMP #$07+128+8
       BNE c00
       LDA #$07+08+128+8
       STA weich
       JSR hart
c00    RTS
weich  DB $07+08+128+8

hart
       LDX #$00
kl     LDA $0c00+601,x
       STA $0c00+600,x
       LDA $0c00+601+40,x
       STA $0c00+600+40,x
       INX
       CPX #39
       BNE kl
       JSR txaus
       RTS

vORne
       JSR zhoLEN
       STA $0c00+639
       ORA #128
       STA $0c00+639+40
       RTS

hINTen
       LDA $0c00+639
       ORA #64
       STA $0c00+639
       LDA $0c00+639+40
       ORA #64
       STA $0c00+639+40
       RTS

weins
       DB 24+7-8
wzwei
       DB 7-7
yup
       DEC weins
       INC wzwei
       LDA weins
       CMP #23-8
       BNE qwe
       LDA #24+7-8
       STA weins
       LDA #7-7
       STA wzwei
qwe    LDA weins
       CMP #24-8
       BNE kal
       JSR hartyu
kal    RTS
aktiv  DB $00


hartyu
       JSR scrutx
       LDX #39
law    LDA $0c00+680+40,x
       LDA $0c00+680+00,x
       LDA $0c00+720+40,x
       STA $0c00+720+00,x
       LDA $0c00+760+40,x
       STA $0c00+760+00,x
       LDA $0c00+800+40,x
       STA $0c00+800+00,x
       LDA $0c00+840+40,x
       STA $0c00+840+00,x
       LDA $0c00+880+40,x
       STA $0c00+880+00,x
       LDA $0c00+920+40,x
       STA $0c00+920+00,x
       LDA $0c00+960+40,x
       STA $0c00+960+00,x
       DEX
       BPL law
       INC aktiv
       RTS

scrutx
       LDX #$00
kap    LDA $7800,x
       STA $0c00+1000,x
       INX
       CPX #40
       BNE kap
       CLC
       LDA kap+1
       ADC #40
       STA kap+1
       BCC la
       INC kap+2
la     RTS
yDOwn
       INC weins
       DEC wzwei
       LDA weins
       CMP #24+8-8
       BNE dwe
       LDA #24-8
       STA weins
       LDA #7
       STA wzwei
dwe    LDA weins
       CMP #25-8
       BNE yal
       JSR hartDOwn
yal    RTS

hartDOwn
       LDX #39
lpo    LDA $0c00+960+00,x
       STA $0c00+960+40,x
       LDA $0c00+920+00,x
       STA $0c00+920+40,x
       LDA $0c00+880+00,x
       STA $0c00+880+40,x
       LDA $0c00+840+00,x
       STA $0c00+840+40,x
       LDA $0c00+800+00,x
       STA $0c00+800+40,x
       LDA $0c00+760+00,x
       STA $0c00+760+40,x
       LDA $0c00+720+00,x
       STA $0c00+720+40,x
       LDA $0c00+680+00,x
       STA $0c00+680+40,x
       DEX
       BPL lpo
       INC aktiv
       RTS

upcol
       LDX #39
low    LDA $6102,x
       STA $0800+720,x
       LDA $6101,x
       STA $0800+720+40,x
       LDA $6100,x
       STA $0800+720+80,x
       LDA $6100,x
       STA $0800+720+120,x
       LDA $6101,x
       STA $0800+720+160,x
       LDA $6102,x
       STA $0800+720+200,x
       LDA $6102,x
       STA $0800+720+240,x
       DEX
       BPL low
       RTS

colmove
       DEC ver
       BNE koa
       LDA #$02
       STA ver
       LDY $612f
       LDX #$2e
nre    LDA $6100,x
       STA $6101,x
       DEX
       BPL nre
       STY $6100
koa    RTS
ver    DB $02

upmanag

lol    LDX $6500
       TXA
       AND #%10000000
       BNE DOwn
       TXA
       BEQ loq
       JSR yup
       JMP loq
DOwn
       TXA
       AND #%01111111
       CMP #$10
       BEQ ulf
       JSR yDOwn
loq    INC lol+1
       BNE moa
       INC lol+2
moa    RTS
ulf
       LDX #$00
       LDY #$65
       STX lol+1
       STY lol+2
       DEC pages
       BNE mer
       LDA #$02
       STA pages
       LDX #$00
       LDY #$78
       STX kap+1
       STY kap+2
mer    RTS
pages
       DB $02

zhoLEN
qqq    LDA $6a00
       BEQ mai
       INC qqq+1
       BNE mso
       INC qqq+2
mso    RTS
mai
       LDX #$00
       LDY #$6a
       STX qqq+1
       STY qqq+2
       JMP zhoLEN

       RTS


LOGo
       LDX #$00
owp    LDA $7e00,x
       STA $0c00+40+10,x
       LDA #$08
       STA $0800+40+10,x
       INX
       BNE owp
       LDX #$0a
llp    LDA $7f00,x
       STA $0d00+40+10,x
       LDA #$08
       STA $0900+40+10,x
       DEX
       BPL llp
       RTS
